//+------------------------------------------------------------------+
//|                                               Pending Orders.mq5 |
//|                              Copyright  2016, Vladimir Karputov |
//|                                           http://wmua.ru/slesar/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, Vladimir Karputov"
#property link      "http://wmua.ru/slesar/"
#property version     "1.000"
#property description "     "
#property description "     :"
#property description " ,  ,  "

#define MACD_MAGIC 4134862
//---
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
//---
input double   InpLots=0.01;           // 
input int      InpIndent=50;           //    
//---
int            ExtTimeOut=1800;        //  () 
double         m_adjusted_point;       //      3  5 
double         m_indent;               //    
CTrade         m_trade;                // CTrade 
CSymbolInfo    m_symbol;               // CSymbolInfo 
bool           ExtOrdersPlaced=false;  // false ->    
datetime       history_start;          //      HistorySelect() 
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetTimer(ExtTimeOut);
//---   
   m_symbol.Name(Symbol());                  // 
   m_trade.SetExpertMagicNumber(MACD_MAGIC); // 
   m_trade.SetMarginMode();
//---   3  5 
   int digits_adjust=1;
   if(m_symbol.Digits()==3 || m_symbol.Digits()==5)
      digits_adjust=10;
   m_adjusted_point=m_symbol.Point()*digits_adjust;
//---
   m_indent=InpIndent*m_adjusted_point;
//---         
   history_start=TimeCurrent()-60;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(!ExtOrdersPlaced)
     {
      if(!m_symbol.RefreshRates())
         return;
      m_trade.BuyLimit(InpLots,m_symbol.Bid()-m_indent,m_symbol.Name(),0,0,0,0,"buy limit");
      m_trade.SellLimit(InpLots,m_symbol.Ask()+m_indent,m_symbol.Name(),0,0,0,0,"sell limit");
      ExtOrdersPlaced=true;
     }
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---    
   ResetLastError();
   bool update=HistorySelect(history_start,TimeCurrent());
   if(!update)
     {
      Print(" HistorySelect  ",TimeToString(history_start,TIME_DATE|TIME_MINUTES|TIME_SECONDS),
            "  ",TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS));
      return;
     }
//---        
   ulong    ticket;
   double   open_price;
   double   initial_volume;
   datetime time_setup;
   datetime time_done;
   string   symbol;
   string   type;
   long     order_magic;
   long     positionID;
//---     
   uint     total=HistoryOrdersTotal();
//---       
   for(uint i=0;i<total;i++)
     {
      //---         
      if((ticket=HistoryOrderGetTicket(i))>0)
        {
         //---    
         open_price=       HistoryOrderGetDouble(ticket,ORDER_PRICE_OPEN);
         time_setup=       (datetime)HistoryOrderGetInteger(ticket,ORDER_TIME_SETUP);
         time_done=(datetime)HistoryOrderGetInteger(ticket,ORDER_TIME_DONE);
         symbol=HistoryOrderGetString(ticket,ORDER_SYMBOL);
         order_magic=      HistoryOrderGetInteger(ticket,ORDER_MAGIC);
         positionID =      HistoryOrderGetInteger(ticket,ORDER_POSITION_ID);
         initial_volume=HistoryOrderGetDouble(ticket,ORDER_VOLUME_INITIAL);
         type=GetOrderType(HistoryOrderGetInteger(ticket,ORDER_TYPE));
         //---       
         printf("#ticket %d %s %G %s at %G was set up at %s => done at %s, order magic=%d, pos ID=%d",
                ticket,                  //   
                type,                    //  
                initial_volume,          //   
                symbol,                  // ,    
                open_price,              //    
                TimeToString(time_setup),//    
                TimeToString(time_done), //     
                order_magic,             // 
                positionID               // ID ,       
                );
        }
     }
//--- 
  }
//+------------------------------------------------------------------+ 
//|                         | 
//+------------------------------------------------------------------+ 
string GetOrderType(long type)
  {
   string str_type="unknown operation";
   switch((int)type)
     {
      case (ORDER_TYPE_BUY):            return("buy");
      case (ORDER_TYPE_SELL):           return("sell");
      case (ORDER_TYPE_BUY_LIMIT):      return("buy limit");
      case (ORDER_TYPE_SELL_LIMIT):     return("sell limit");
      case (ORDER_TYPE_BUY_STOP):       return("buy stop");
      case (ORDER_TYPE_SELL_STOP):      return("sell stop");
      case (ORDER_TYPE_BUY_STOP_LIMIT): return("buy stop limit");
      case (ORDER_TYPE_SELL_STOP_LIMIT):return("sell stop limit");
     }
   return(str_type);
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction &trans,
                        const MqlTradeRequest &request,
                        const MqlTradeResult &result)
  {
//---

  }
//+------------------------------------------------------------------+
